//
//	cz crypt header
//
#ifndef __czcrypt_h
#define __czcrypt_h

typedef struct {
	short	year;		// N
	char	month;		// 
	char	day;		// 

	char	hour;		// 
	char	min;		// 
	char	sec;		// b
	char	msec;		// ~b

	char	rnd[8];		// l
} OURGUID;


class CzCrypt {
public:
	CzCrypt();
	~CzCrypt();

	int				DataSet( char *ptr, int size );			// ƃobt@ݒ肷
	int				DataLoad( char *file );					// t@C̓e[hăobt@Ƃ
	int				DataSave( char *file );					// obt@̓et@Cɏo
	int				Encrypt( void );						// obt@Í
	int				Decrypt( void );						// obt@𕜍
	int				GetSize( void );						// obt@TCY擾
	char*			GetData( void );						// obt@ւ̃|C^擾
	void			SetGUID( OURGUID *guid );				// Í/̂߂̃R[hGUIDݒ肷
	void			SetSeed( int seed1, int seed2 );		// Í/̂߂̃R[hSEEDݒ肷
	void			MakeGUID( OURGUID *guid );				// GUIDVKɍ쐬

	int				GetCRC32( void );						// CRC32l擾
	void			GetMD5( char *res );					// MD5l擾
	void			GetMD5ext( char *res, char *buf, int size );	// MD5l擾

	int				EncodeBASE64( char *dstptr, char *srcptr, int size );
	int				DecodeBASE64( char *dstptr, char *srcptr, int size );
	int				GetBASE64Size( int size );
	int				EncodeRC4( char *ptr, char *key, int size );
	int				DecodeRC4( char *ptr, char *key, int size );


private:
	//		private data
	//
	char*			buffer;									// Ώۃf[^
	int				size;									// Ώۃf[^TCY

	char			randtable[128];							// Í/pe[u


	unsigned int	r_s1,r_s2,r_s3;
	double			rnd_d1,rnd_d2,rnd_d3;

	//		private function
	//
	void			initrnd( int seed );
	double			makernd( void );
	int				makerndi( void );
};


#endif
